



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>poj2991 Crane(线段树+集合)白书例题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">poj2991 Crane(线段树+集合)白书例题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 15:45:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：起重机有n节，题目给出要调节的k节，每节调节成x度，求最后底部的起重机的坐标（最顶上的起点为（0，0））。</p>
<p>分析：一开始我看白书，看不懂他那个向量旋转的坐标是怎么来的，翻了很多博客，才发现，是自己数学基础的遗漏（都怪自己高中没好好学T.T），向量旋转涉及到复数的概念和表达。</p>
<p>首先复数表达式z=x+i*y=|z|*(cosx+i*sinx)（i&sup2;=-1）,假设两个个复数分别为</p>
<p>z1=x1+y1*i=r1*(cos(p1)+i*sin(p1))</p>
<p>z2=x2+y2*i=r2*(cos(p2)+i*sin(p2))</p>
<p>(r1=|z|,r2=|z|)</p>
<p>z1*z2=r1*r2*(cos(p1+p2)+i*sin(p1+p2))</p>
<p>由上面的结果可以知道两个向量乘积可以看作两个模的乘积，两个向量角度相加。</p>
<p>由这结论可以得到一个向量（x,y）,乘上旋转p1度模为1的复数（cos(p1)+i*sin(p1)）即</p>
<p>(x+y*i)*(cos(p1)+i*sin(p1))=x*cos(p1)-y*sin(p1)+(y*cos(p1)+x*sin(p1))*i</p>
<p>由此可得向量(x,y)旋转p1度后的向量为( x*cos(p1)-y*sin(p1),(y*cos(p1)+x*sin(p1)) )</p>
<p>即x'= x*cos(p1)-y*sin(p1),y'=y*cos(p1)+x*sin(p1)</p>
<p>另外再说明一下，白书的某个节点的的向量表达上为：<strong>该点向量坐标=左儿子节点的向量+</strong><strong>右儿子节点的向量（旋转的向量）</strong></p>
<p>这题让真的让我收益非凡</p>
<p>下面附上代码</p>
<div>
<pre class="prettyprint linenums">#define debug<br />
#include&lt;stdio.h&gt;<br />
#include&lt;math.h&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;stack&gt;<br />
#include&lt;string&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;string.h&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;functional&gt;<br />
#include&lt;iomanip&gt;<br />
#include&lt;map&gt;<br />
#include&lt;set&gt;<br />
#define pb push_back<br />
using namespace std;<br />
typedef long long ll;<br />
pair&lt;ll,ll&gt;PLL;<br />
pair&lt;int,ll&gt;Pil;<br />
const int INF = 0x3f3f3f3f;<br />
const double inf=1e8+100;<br />
const int maxn =(1&lt;&lt;15)-1;<br />
const int N = 1e4+10;<br />
const ll mod=1000007;<br />
const double eps=1e-8;<br />
const double g=10.0;<br />
const double PI=acos(-1.0);<br />
int n,c;<br />
int L[N];<br />
int S[N],A[N];<br />
double vx[maxn],vy[maxn],ang[maxn];<br />
double prv[maxn];

void init(int k,int l,int r) {<br />
	ang[k]=vx[k]=0.0;<br />
	//<br />
	if(r-l==1) {<br />
		vy[k]=L[l];<br />
	} else {<br />
		int chl=2*k+1,chr=2*k+2;<br />
		init(chl,l,(r+l)/2);<br />
		init(chr,(r+l)/2,r);<br />
		vy[k]=vy[chl]+vy[chr];<br />
	}<br />
}

void change(int s, double a,int v,int l,int r) {<br />
	if(s&lt;=l)<br />
		return;<br />
	else if(s&lt;r) {<br />
		int chl=2*v+1,chr=2*v+2;<br />
		int m=(r+l)/2;<br />
		change(s,a,chl,l,m);<br />
		change(s,a,chr,m,r);<br />
		if(s&lt;=m)<br />
			ang[v]+=a;<br />
		double ss=sin(ang[v]),cc=cos(ang[v]);<br />
		vx[v]=vx[chl]+(cc*vx[chr]-ss*vy[chr]);<br />
		vy[v]=vy[chl]+(ss*vx[chr]+cc*vy[chr]);<br />
	}<br />
}

void solve() {<br />
	int i,j,cnt=0;<br />
	while(~scanf("%d%d",&amp;n,&amp;c)) {<br />
		if(cnt++){<br />
			puts("");<br />
		}<br />
		for(i=0; i&lt;n; i++) {<br />
		//	cin&gt;&gt;L[i];<br />
		scanf("%d",&amp;L[i]);<br />
		}<br />
		for(i=0; i&lt;c; i++) {<br />
		//	cin&gt;&gt;S[i]&gt;&gt;A[i];<br />
		scanf("%d%d",&amp;S[i],&amp;A[i]);<br />
		}<br />
		//<br />
		init(0,0,n);<br />
		for(i=1; i&lt;n; i++) {<br />
			prv[i]=PI;<br />
		}<br />
		for(i=0; i&lt;c; i++) {<br />
			int s=S[i];<br />
			double a=A[i]/180.0*PI;<br />
		//	cout&lt;&lt;s&lt;&lt;" "&lt;&lt;A[i]&lt;&lt;" "&lt;&lt;a&lt;&lt;endl;<br />
			change(s,a-prv[s],0,0,n);<br />
			prv[s]=a;<br />
		//	cout&lt;&lt;fixed&lt;&lt;setprecision(2)&lt;&lt;vx[0]&lt;&lt;" "&lt;&lt;vy[0]&lt;&lt;endl;<br />
			printf("%.2f %.2f\n",vx[0],vy[0]);<br />
		}<br />
	}<br />
}

int main() {<br />
//	ios_base::sync_with_stdio(false);<br />
#ifdef debug<br />
	freopen("in.txt", "r", stdin);<br />
//	freopen("out.txt","w",stdout);<br />
#endif<br />
//	cin.tie(0);<br />
//	cout.tie(0);<br />
	solve();<br />
	return 0;<br />
}
</pre>
</div>
<p>　　若有写的好不的地方，欢迎指出</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z1r519.html">&lbrack;css&rsqb;全屏背景图片设置&comma;django加载图片路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxnxdd8.html">sql server多重行列转置的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8me6epq.html">修改Linux系统日期与时间date clock</a>
		</li>
						<li><a href="https://www.batexi.com/a/390grg38.html">paip&period;代码生成器数据源格式最佳实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykpzm9.html">&lbrack;ML&rsqb; Naive Bayes for Text Classification</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w227oq.html">CDATA</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjy3xd9.html">android程序的安装与卸载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm6onl9.html">学习Swift -- 构造器（上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn174j28.html">表格td标签在不添加多余标签的情况下实现文本内容单行显示，多余部分省略号表示的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyojwk9.html">ThreadLocal笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd70oz9.html">支持向量机&lpar;Support Vector Machine&rpar;-----SVM之SMO算法&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eykjwe9.html">漫谈Web缓存架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/950kpp08.html">Android 添加library的时候出错添加不上</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pedrn8.html">算法笔记-exgcd</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodynnq.html">ECMAScript 6 学习（一）generator函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj310j8.html">iOS开发基础-Plist实现嵌套模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrkyw8.html">Spring Cloud微服务Ribbon负载均衡&sol;Zuul网关使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o146o5q.html">docker 12 docker容器数据卷</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o00318.html">JVM 字节码（一）字节码规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwy3678.html">DotNetBar ButtonX添加下拉面板</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpldrr9.html">Caused by&colon; org&period;springframework&period;beans&period;factory&period;BeanCreationException&colon; Could not autowire field</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1knnz29.html">芝麻HTTP：非关系型数据库存储</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpllkr9.html">Unity开发之实现更换鼠标图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z25x59.html">C&num;图解教程 第八章 表达式和运算符</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yl1ow8.html">SqlBulkCopy 批量复制数据到数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp3vwvq.html">css补充</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zw12j9.html">jQuery框架-2&period;jQuery操作DOM节点与jQuery&period;ajax方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pkw348.html">新的一年新的变化！IT的大变天</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1oyvxq.html">&lbrack;BZOJ3110&rsqb;&lbrack;ZJOI2013&rsqb;K大数查询（整体二分）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzro2w8.html">&lbrack;POI2014&rsqb;KUR-Couriers</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
